// serial port parameter settings
//-------------------------------
#define COM1_BASE         1016         // 3f8 hex (uart base address)
#define COM2_BASE          760         // 2f8 hex
#define COM3_BASE         1000         // 3e8 hex
#define COM4_BASE          744         // 2e8 hex

#define IRQ_0                0         // irq no.
#define IRQ_1                1
#define IRQ_2                2
#define IRQ_3                3
#define IRQ_4                4
#define IRQ_5                5
#define IRQ_6                6
#define IRQ_7                7

#define BAUD_300           384         // baud rate
#define BAUD_1200           96
#define BAUD_2400           48
#define BAUD_4800           24
#define BAUD_9600           12
#define BAUD_19200           6
#define BAUD_38400           3
#define BAUD_57600           2
#define BAUD_115200          1

// processing codes
//-----------------
#define IDLE                 0         // dce response code:
#define HANDSHAKING          1         // ABORT, ERROR & CONNECT are also used
#define TRANSFERING          2
#define FINISH               3

// result codes
//-------------
#define IN_TIMEOUT           1         // serial error code
#define IN_ERROR             2
#define OUT_TIMEOUT          3
#define OUT_ABORT            4
#define DCE_NOT_READY        5

#define OK                   6         // dce response code
#define ABORT                7
#define BUSY                 8
#define ERROR                9
#define NO_ANSWER           10
#define NO_CARRIER          11
#define NO_DIALTONE         12
#define RING                13
#define RINGING             14
#define CONNECT             15

#define OPEN_ERROR           256
#define FORMAT_ERROR         257
#define OUT_OF_MEMORY_ERROR  258
#define FONT_OPEN_ERROR      259
#define FONT_READ_ERROR      260
#define FONT_SEEK_ERROR      261
#define ASC_OPEN_ERROR       262


// modem parameter settings
//-------------------------
#define TONE                 0         // dial modes
#define PULSE                1

#define SPK_ALWAYS_OFF       0         // speaker always off
#define SPK_CONNECT_OFF      1         // speaker on until connected
#define SPK_ALWAYS_ON        2         // speaker always on
#define SPK_DIAL_OFF         3         // speaker off when dialing or connected


// fax parameter settings
//-----------------------
#define MH                   0         // compression method
#define MR                   1

#define A4                   0         // page length
#define B4                   1
#define UNLIMITED            2

#define NORMAL               0         // resolution
#define FINE                 1
#define AUTO_RESOLUTION      2
